/*
*  Touch Sensing Library System Setup File
*
*  Auto-generated by Processor Expert TSS_Library Component
*
*  This file contains electrode and other Touch Sensing System setup parameters
*/
#ifndef __TSS_SYSTEM_SETUP_H__
#define __TSS_SYSTEM_SETUP_H__


#define TSS_USE_PE_COMPONENT                   1      /* Macro indicates TSS Component usage */

#define TSS_KINETIS_MCU                        1      /* Macro defines MCU platform */

#define TSS_MCU_SUBFAMILY_KL25                 1      /* Macro defines MCU subfamily */

#define TSS_USE_MQX                            1      /* MQX operating system is used */

/*********************** TSS Features Configuration **************************/

#define TSS_USE_SIMPLE_LOW_LEVEL               0      /* Simple Low Level support */

#define TSS_USE_DELTA_LOG                      1      /* Delta Log array support */

#define TSS_USE_SIGNAL_LOG                     1      /* Signal Log array support */

#define TSS_USE_FREEMASTER_GUI                 0      /* FreeMASTER GUI support */

#define TSS_USE_CONTROL_PRIVATE_DATA           0      /* Control Private Data support */

#define TSS_USE_AUTO_SENS_CALIBRATION          1      /* Automatic Sensitivity Calibration support */

#define TSS_USE_AUTO_SENS_CALIB_INIT_DURATION  100    /* Automatic Sensitivity Calibration initialization duration */

#define TSS_USE_BASELINE_INIT_DURATION         15     /* Baseline initialization duration */

/* Signal Control Options */

#define TSS_USE_GPIO_STRENGTH                  0      /* Electrode GPIO Strength support */

#define TSS_USE_GPIO_SLEW_RATE                 0      /* Electrode GPIO Slew Rate support */

#define TSS_USE_IIR_FILTER                     0      /* IIR Filter support */

#define TSS_USE_NOISE_AMPLITUDE_FILTER         0      /* Noise Amplitude Filter function support */

#define TSS_USE_SIGNAL_SHIELDING               0      /* Signal Shielding support */

#define TSS_USE_SIGNAL_DIVIDER                 0      /* Signal Divider support */

#define TSS_USE_SIGNAL_MULTIPLIER              0      /* Signal Multiplier support */

#define TSS_USE_DEFAULT_ELECTRODE_LEVEL_LOW    0      /* Default Electrode Level support */

/* Feature Control Source Definition */

#define TSS_USE_AUTOTRIGGER_SOURCE             UNUSED /* Identifier of the Auto Trigger source device */

#define TSS_USE_LOWPOWER_CONTROL_SOURCE        UNUSED /* Identifier of the Low Power control source device */

/* Code Size Reduction Options */

#define TSS_USE_DATA_CORRUPTION_CHECK          1      /* Data Corruption of TSS registers support */

#define TSS_USE_TRIGGER_FUNCTION               1      /* Trigger Function support */

#define TSS_USE_STUCK_KEY                      1      /* Stuck-key function support */

#define TSS_USE_NEGATIVE_BASELINE_DROP         1      /* Negative Baseline Drop support */

#define TSS_USE_AUTO_HW_RECALIBRATION          1      /* Automatic HW recalibration */

/* Callback Definition */

#define TSS_ONFAULT_CALLBACK                   TSS1_fOnFault /* Identifier of the user's OnFault callback */

#define TSS_ONINIT_CALLBACK                    TSS1_fOnInit /* Identifier of the user's OnInit callback */

/* Debug Options */

#define TSS_ENABLE_DIAGNOSTIC_MESSAGES         0      /* Diagnostic Messages support */

/**************************** Electrode Configuration **************************/

#define TSS_N_ELECTRODES            2                 /* Number of electrodes present in the system */

/* Electrode's Pin Configuration */

/* Configuration of Electrode Measurement Method */

#define TSS_E0_TYPE                 TSI0_CH9          /* Electrode measurement method specification */
#define TSS_E1_TYPE                 TSI0_CH10         /* Electrode measurement method specification */

/************************** Controls Configuration ***************************/

#define TSS_N_CONTROLS              1

#define TSS_C0_TYPE                 TSS_CT_ASLIDER    /* Control type */
#define TSS_C0_ELECTRODES           2                 /* Number of electrodes in the control */
#define TSS_C0_STRUCTURE            AnalogSlider      /* Name of the C&S struct to create */
#define TSS_C0_CALLBACK             TSS1_fCallBack0   /* Identifier of the user's callback */

/********************* Peripheral Specific Configuration *********************/

/* TSI Specific Parameters */

#define TSS_TSI_RESOLUTION               4            /* Required Bit resolution of the TSI */

/* Active Mode Clock Settings */
#define TSS_TSI_AMCLKS              0                 /* Input Active Mode Clock Source ( 0 = BUSclk, 1 = MCGIRCLK, 2 = OSCERCLK, 3 - NA ) */
#define TSS_TSI_AMPSC               0                 /* Input Active Mode Clock Prescaler ( 0 = divide 1, 7 = divide 128 ) */
#define TSS_TSI_AMCLKDIV            1                 /* Input Active Mode Clock Divider ( 0 = divide 1, 1 = divide 2048 ) */
/* Low Power TSI definition */
#define TSS_TSI_LPCLKS              0                 /* Low Power Mode Clock Source ( 0 = LPOCLK, 1 = VLPOSCCLK ) */
/* Scan Settings */

#endif /*__TSS_SYSTEM_SETUP_H__*/
