/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DMA1.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : DMA_LDD
**     Version     : Component 01.061, Driver 01.07, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-10-01, 10:16, # CodeGen: 4
**     Abstract    :
**          This embedded component implements initialization
**          and runtime handling of an on-chip DMA controller.
**     Settings    :
**          Component name                                 : DMA1
**          Device                                         : DMA
**          Channel arbitration type                       : Round robin
**          DMA channels                                   : 3
**            Settings of DMA channel                      : DMA_Channel0
**              Channel                                    : DMA_Channel0
**              Channel arbitration type                   : Round robin
**              Interrupt service                          : Enabled
**                Transfer complete interrupt              : INT_DMA0
**                Transfer complete interrupt priority     : medium priority
**            Settings of DMA channel                      : DMA_Channel1
**              Channel                                    : DMA_Channel1
**              Channel arbitration type                   : Round robin
**              Interrupt service                          : Enabled
**                Transfer complete interrupt              : INT_DMA1
**                Transfer complete interrupt priority     : medium priority
**            Settings of DMA channel                      : DMA_Channel2
**              Channel                                    : DMA_Channel2
**              Channel arbitration type                   : Round robin
**              Interrupt service                          : Disabled
**          Initialization                                 : 
**            Enabled in init. code                        : yes
**            Auto initialization                          : yes
**          CPU clock/configuration selection              : 
**            Clock configuration 0                        : This component enabled
**            Clock configuration 1                        : This component disabled
**            Clock configuration 2                        : This component disabled
**     Contents    :
**         Init                         - LDD_TDeviceData* DMA1_Init(LDD_TUserData *UserDataPtr);
**         Deinit                       - void DMA1_Deinit(LDD_TDeviceData *DeviceDataPtr);
**         Enable                       - LDD_TError DMA1_Enable(LDD_TDeviceData *DeviceDataPtr);
**         Disable                      - LDD_TError DMA1_Disable(LDD_TDeviceData *DeviceDataPtr);
**         AllocateChannel              - LDD_TError DMA1_AllocateChannel(LDD_TDeviceData *DeviceDataPtr,...
**         EnableChannel                - LDD_TError DMA1_EnableChannel(LDD_TDeviceData *DeviceDataPtr,...
**         DisableChannel               - LDD_TError DMA1_DisableChannel(LDD_TDeviceData *DeviceDataPtr,...
**         StartChannelTransfer         - LDD_TError DMA1_StartChannelTransfer(LDD_TDeviceData *DeviceDataPtr,...
**         CancelChannelTransfer        - LDD_TError DMA1_CancelChannelTransfer(LDD_TDeviceData *DeviceDataPtr,...
**         GetChannelStatus             - LDD_DMA_TChannelStatus DMA1_GetChannelStatus(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelSourceAddress      - LDD_TError DMA1_SetChannelSourceAddress(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelDestinationAddress - LDD_TError DMA1_SetChannelDestinationAddress(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelByteCount          - LDD_TError DMA1_SetChannelByteCount(LDD_TDeviceData *DeviceDataPtr,...
**         GetChannelDescriptorUpdate   - LDD_TError DMA1_GetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr,...
**         SetChannelDescriptorUpdate   - LDD_TError DMA1_SetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE DMA1. */

#include "Events.h"
#include "DMA1.h"

/* {Default RTOS Adapter} No RTOS includes */

/* {Default RTOS Adapter} Static object used for simulation of dynamic driver memory allocation */
static DMA1_TDeviceData DeviceDataPtr__DEFAULT_RTOS_ALLOC;
/* {Default RTOS Adapter} Global variable used for passing a parameter into ISR */
static DMA1_TDeviceData * INT_DMA0__DEFAULT_RTOS_ISRPARAM;
/* {Default RTOS Adapter} Global variable used for passing a parameter into ISR */
static DMA1_TDeviceData * INT_DMA1__DEFAULT_RTOS_ISRPARAM;
/* Channel numbers initialization table */
static const LDD_DMA_TChannelNumber DMA1_ChannelNumbers[DMA1_CONFIGURED_CHANNELS_NUMBER] = {
  0x00U,
  0x01U,
  0x02U
};
/* Channel interrupts enable initialization table */
static const bool DMA1_ChannelInterrupts[DMA1_CONFIGURED_CHANNELS_NUMBER] = {
  TRUE,
  TRUE,
  FALSE
};

/* Internal method prototypes */
static bool GetRecord(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, DMA1_TDescriptorRecordPtr *DescriptorRecordAddressPtr);
static bool GetChannelNumber(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TChannelNumber *ChannelNumberPtr);
static bool VerifyDescriptor(LDD_DMA_TTransferDescriptor *DescriptorPtr);
static void InitChannel(LDD_TDeviceData *DeviceDataPtr, DMA1_TDescriptorRecord *DescriptorRecordPtr);

/*
** ===================================================================
**     Method      :  DMA1_Init (component DMA_LDD)
**
**     Description :
**         Initializes the device according to design-time
**         configuration properties. Allocates memory for the device
**         data structure. 
**         If the <Enable in init. code> is set to "yes" then the
**         device is also enabled (see the description of the Enable
**         method).
**         This method can be called only once. Before the second call
**         of Init the Deinit method must be called first.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     Returns     :
**         ---             - Pointer to the device data structure. 
** ===================================================================
*/
LDD_TDeviceData* DMA1_Init(LDD_TUserData *UserDataPtr)
{
  uint8_t i;
  DMA1_TDeviceData *DeviceDataPtr;     /* LDD device structure */
  DMA1_TDescriptorRecord *DescriptorRecordPtr; /* Auxiliary local pointer to internal descriptor records. */

  /* Allocate HAL device structure */
  /* {Default RTOS Adapter} Driver memory allocation: Dynamic allocation is simulated by a pointer to the static object */
  DeviceDataPtr = &DeviceDataPtr__DEFAULT_RTOS_ALLOC;
  DeviceDataPtr->UserDataPtr = UserDataPtr; /* Store the RTOS device structure */
  /* Enable device clock gate */
  /* SIM_SCGC7: DMA=1 */
  SIM_SCGC7 |= SIM_SCGC7_DMA_MASK;                                                   
  /* SIM_SCGC6: DMAMUX=1 */
  SIM_SCGC6 |= SIM_SCGC6_DMAMUX_MASK;                                                   
  /* Transfer compete interrupt vector(s) allocation */
  /* {Default RTOS Adapter} Set interrupt vector: IVT is static, ISR parameter is passed by the global variable */
  INT_DMA0__DEFAULT_RTOS_ISRPARAM = DeviceDataPtr;
  /* Transfer compete interrupt vector(s) priority setting */
  /* NVIC_IPR0: PRI_0=0x80 */
  NVIC_IPR0 = (uint32_t)((NVIC_IPR0 & (uint32_t)~(uint32_t)(
               NVIC_IP_PRI_0(0x7F)
              )) | (uint32_t)(
               NVIC_IP_PRI_0(0x80)
              ));                                                  
  /* NVIC_ISER: SETENA|=1 */
  NVIC_ISER |= NVIC_ISER_SETENA(0x01);                                                   
  /* Transfer compete interrupt vector(s) allocation */
  /* {Default RTOS Adapter} Set interrupt vector: IVT is static, ISR parameter is passed by the global variable */
  INT_DMA1__DEFAULT_RTOS_ISRPARAM = DeviceDataPtr;
  /* Transfer compete interrupt vector(s) priority setting */
  /* NVIC_IPR0: PRI_1=0x80 */
  NVIC_IPR0 = (uint32_t)((NVIC_IPR0 & (uint32_t)~(uint32_t)(
               NVIC_IP_PRI_1(0x7F)
              )) | (uint32_t)(
               NVIC_IP_PRI_1(0x80)
              ));                                                  
  /* NVIC_ISER: SETENA|=2 */
  NVIC_ISER |= NVIC_ISER_SETENA(0x02);                                                   
  for (i = 0U; i < DMA1_DMA_CHANNELS_NUMBER; i++) {
    DMA_PDD_WriteControlReg(DMA_BASE_PTR, i, 0U); /* Clear control register. Disable all interrupts and HW requests. */
    DMA_PDD_ClearInterruptFlags(DMA_BASE_PTR, i, DMA_PDD_TRANSFER_COMPLETE_FLAG); /* Clear request interrupt flags */
  }
  /* Initialization of channels record field. */
  for(i = 0U; i < DMA1_DMA_CHANNELS_NUMBER; i++) {
    DeviceDataPtr->ChannelRecord[i] = NULL; /* Clear pointer to descriptor record of all channels. */
  }
  /* Initialization of channel and descriptor record fields. */
  for(i = 0U; i < DMA1_CONFIGURED_CHANNELS_NUMBER; i++) {
    DescriptorRecordPtr = &(DeviceDataPtr->DescriptorRecord[i]); /* Store local pointer to descriptor record. */
    DescriptorRecordPtr->ChannelNumber = DMA1_ChannelNumbers[i]; /* Store associated channel number. */
    DescriptorRecordPtr->DescriptorPtr = NULL; /* Set channel as free. */
    DescriptorRecordPtr->Interrupts = DMA1_ChannelInterrupts[i]; /* Store associated channel interrupts enabled/disabled status. */
    DescriptorRecordPtr->Initialized = FALSE; /* Set channel as not initialized. */
    DescriptorRecordPtr->Enabled = FALSE; /* Set channel as disabled. */
    DeviceDataPtr->ChannelRecord[DMA1_ChannelNumbers[i]] = DescriptorRecordPtr; /* Store pointers to descriptor records of fixed channels. */
    DeviceDataPtr->EventMask[DMA1_ChannelNumbers[i]] = 0U; /* Clear channel event mask. */
  }
  DeviceDataPtr->EnUser = TRUE;        /* Set the flag "device enabled by user" */
  /* Registration of the device structure */
  PE_LDD_RegisterDeviceStructure(PE_LDD_COMPONENT_DMA1_ID,DeviceDataPtr);
  return ((LDD_TDeviceData *)DeviceDataPtr); /* Return pointer to the data structure */
}

/*
** ===================================================================
**     Method      :  DMA1_Deinit (component DMA_LDD)
**
**     Description :
**         Deinitializes the associated peripheral(s) and frees the
**         component internal data structure.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/
void DMA1_Deinit(LDD_TDeviceData *DeviceDataPtr)
{
  (void)DeviceDataPtr;                 /* Parameter not used, suppress not used argument warning */
  /* Restoring the interrupt vectors */
  /* {Default RTOS Adapter} Restore interrupt vector: IVT is static, no code is generated */
  /* {Default RTOS Adapter} Restore interrupt vector: IVT is static, no code is generated */
  /* Unregistration of the device structure */
  PE_LDD_UnregisterDeviceStructure(PE_LDD_COMPONENT_DMA1_ID);
  /* Deallocation of the device structure */
  /* {Default RTOS Adapter} Driver memory deallocation: Dynamic allocation is simulated, no deallocation code is generated */
  /* Disable device clock gate */
  /* SIM_SCGC7: DMA=0 */
  SIM_SCGC7 &= (uint32_t)~(uint32_t)(SIM_SCGC7_DMA_MASK);                                                   
}

/*
** ===================================================================
**     Method      :  DMA1_Enable (component DMA_LDD)
**
**     Description :
**         Enables DMA device.
**         This method is intended to be used together with Disable
**         method to temporary switch On/Off the device after the
**         device is initialized.
**         This method is required if the <Enable in init. code>
**         property is set to "no" value.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
** ===================================================================
*/
LDD_TError DMA1_Enable(LDD_TDeviceData *DeviceDataPtr)
{
  ((DMA1_TDeviceData *)DeviceDataPtr)->EnUser = TRUE;
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_Disable (component DMA_LDD)
**
**     Description :
**         Disables the DMA device. When the device is disabled, some
**         component methods should not be called. If so, error
**         ERR_DISABLED is reported.
**         This method is intended to be used together with Enable
**         method to temporary switch On/Off the device after the
**         device is initialized.
**         This method is not required. The Deinit method can be used
**         to switch off and uninstall the device.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
** ===================================================================
*/
LDD_TError DMA1_Disable(LDD_TDeviceData *DeviceDataPtr)
{
  ((DMA1_TDeviceData *)DeviceDataPtr)->EnUser = FALSE;
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_AllocateChannel (component DMA_LDD)
**
**     Description :
**         The method allocates DMA channel for the DMA transfer
**         defined by the transfer descriptor input parameter
**         DescriptorPtr. This method must be called before DMA channel
**         is initialized. Otherwise ERR_NOTAVAIL error code is
**         returned after call of DMA_LDD channel methods.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any possible
**                           channel with desired features to be
**                           allocated.
** ===================================================================
*/
LDD_TError DMA1_AllocateChannel(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  DMA1_TDeviceData *LocalDeviceDataPtr = (DMA1_TDeviceData *)DeviceDataPtr; /* Auxiliary variable - pointer to an internal state structure */
  DMA1_TDescriptorRecord *DescriptorRecordPtr; /* Auxiliary local pointer to internal descriptor records. */
  bool ChannelFound = FALSE;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  if (!DescriptorPtr->ChannelAutoSelection) { /* Fixed channel wanted? */
    DescriptorRecordPtr = LocalDeviceDataPtr->ChannelRecord[DescriptorPtr->ChannelNumber]; /* Store local pointer to internal descriptor record. */
    if (DescriptorRecordPtr->DescriptorPtr == NULL) { /* Is channel free? */
      /* Allocate channel */
      DescriptorRecordPtr->DescriptorPtr = DescriptorPtr;
      ChannelFound = TRUE;
    }
  }
  if (ChannelFound) {
    return ERR_OK;
  }
  else {
    return ERR_NOTAVAIL;
  }
}

/*
** ===================================================================
**     Method      :  DMA1_EnableChannel (component DMA_LDD)
**
**     Description :
**         The method initializes and/or enables the DMA channel
**         allocated for the DMA transfer defined by the transfer
**         descriptor input parameter DescriptorPtr. First call of this
**         method on given DMA channel initializes it and enables HW
**         requests if Peripheral device or Always enabled trigger
**         source is selected in transfer descriptor Trigger source
**         type item. This method can be also used together with
**         Disable method to temporary switch On/Off the DMA channel HW
**         requests. In such case DMA channel registers are not
**         reinitialized again. New initialization of DMA channel can
**         be done via SetChannelDescriptorUpdate method which
**         reinitializes whole channel with new transfer descriptor.
**         After calling of EnableChannel method channel status is set
**         to LDD_DMA_IDLE.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Transfer descriptor data
**                           are inconsistent.
** ===================================================================
*/
LDD_TError DMA1_EnableChannel(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  LDD_DMA_TChannelNumber ChannelNumber;
  DMA1_TDescriptorRecord *DescriptorRecordPtr;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store pointer to associated descriptor record. */
  if (!GetRecord(DeviceDataPtr, DescriptorPtr, &DescriptorRecordPtr)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  /* Transfer descriptor consistency test - this test can be disabled by setting the "Ignore range checking"
     property to the "yes" value in the "Configuration inspector" */
  if (!VerifyDescriptor(DescriptorPtr)) {
    return ERR_PARAM_DATA;
  }
  ChannelNumber = DescriptorRecordPtr->ChannelNumber; /* Save local auxiliary channel number. */
  if (!DescriptorRecordPtr->Initialized) { /* Is channel already initialized? */
    /* If channel is not initialized yet, initialize and enable it */
    InitChannel(DeviceDataPtr, DescriptorRecordPtr);
    /* {Default RTOS Adapter} Critical section begin, general PE function is used */
    EnterCritical();
    DescriptorRecordPtr->Initialized = TRUE; /* Mark channel as initialized. */
    DescriptorRecordPtr->Enabled = TRUE; /* Mark channel as enabled. */
    DescriptorPtr->ChannelEnabled = TRUE; /* Mark channel as enabled in transfer descriptor. */
    if (DescriptorPtr->Interrupts) {   /* Interrupts enabled? */
      DMA_PDD_EnableTransferCompleteInterrupt(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE);
      if (DescriptorPtr->OnComplete) { /* Is transfer complete event enabled? */
        ((DMA1_TDeviceData *)DeviceDataPtr)->EventMask[ChannelNumber] |= LDD_DMA_ON_COMPLETE;
      }
      if (DescriptorPtr->OnError) {    /* Is transfer error event enabled? */
        ((DMA1_TDeviceData *)DeviceDataPtr)->EventMask[ChannelNumber] |= LDD_DMA_ON_ERROR;
      }
    }
    /* DMA channel HW requests source settings */
    DMAMUX_PDD_WriteChannelConfigurationReg(DMAMUX0_BASE_PTR, ChannelNumber, 0U); /* Clear DMA MUX channel source register. */
    if (DescriptorPtr->TriggerType != LDD_DMA_SW_TRIGGER) { /* SW trigger doesn't need MUX channel nor enabled hardware requests. */
      DMAMUX_PDD_SetChannelSource(DMAMUX0_BASE_PTR, ChannelNumber, DescriptorPtr->TriggerSource); /* Set MUX channel source. */
      if (DescriptorPtr->PeriodicTrigger) { /* Periodic trigger needed? */
        DMAMUX_PDD_EnableTrigger(DMAMUX0_BASE_PTR, ChannelNumber, PDD_ENABLE);
      }
      DMAMUX_PDD_EnableChannel(DMAMUX0_BASE_PTR, ChannelNumber, PDD_ENABLE); /* Enable channel. */
      DMA_PDD_EnablePeripheralRequest(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE); /* Enable HW requests. */
    }
    /* {Default RTOS Adapter} Critical section end, general PE function is used */
    ExitCritical();
  }
  else {
    /* If channel has already been initialized then enable it only */
    /* {Default RTOS Adapter} Critical section begin, general PE function is used */
    EnterCritical();
    DescriptorRecordPtr->Enabled = TRUE; /* Mark channel as enabled. */
    DescriptorPtr->ChannelEnabled = TRUE; /* Mark channel as enabled in transfer descriptor. */
    if (DescriptorPtr->TriggerType != LDD_DMA_SW_TRIGGER) { /* SW trigger doesn't need enabled hardware requests. */
      DMA_PDD_EnablePeripheralRequest(DMA_BASE_PTR, DescriptorRecordPtr->ChannelNumber, PDD_ENABLE); /* Enable HW requests */
    }
    /* {Default RTOS Adapter} Critical section end, general PE function is used */
    ExitCritical();
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_DisableChannel (component DMA_LDD)
**
**     Description :
**         The method disables the DMA channel allocated for the DMA
**         transfer defined by the transfer descriptor input parameter
**         DescriptorPtr and disables HW requests services. However, it
**         is still possible to start transfer explicitly as SW
**         transfer requests via StartChannelTransfer method. After
**         calling of DisableChannel method channel status is set to
**         LDD_DMA_IDLE.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/
LDD_TError DMA1_DisableChannel(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  LDD_DMA_TRecordNumber ChannelNumber;
  DMA1_TDescriptorRecord *DescriptorRecordPtr;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store pointer to associated descriptor record. */
  if (!GetRecord(DeviceDataPtr, DescriptorPtr, &DescriptorRecordPtr)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  ChannelNumber = DescriptorRecordPtr->ChannelNumber; /* Save local auxiliary channel number. */
  /* {Default RTOS Adapter} Critical section begin, general PE function is used */
  EnterCritical();
  DescriptorRecordPtr->Enabled = FALSE; /* Mark channel as disabled. */
  DescriptorPtr->ChannelEnabled = FALSE; /* Mark channel as disabled in transfer descriptor. */
  DMA_PDD_EnablePeripheralRequest(DMA_BASE_PTR, ChannelNumber, PDD_DISABLE); /* Disable DMA channel transfer request */
  /* {Default RTOS Adapter} Critical section end, general PE function is used */
  ExitCritical();
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_StartChannelTransfer (component DMA_LDD)
**
**     Description :
**         The method starts DMA transfer on the allocated DMA channel
**         defined by the transfer descriptor input parameter
**         DescriptorPtr. This methods initiates explicit SW transfer
**         request and can be called after channel is initialized by
**         first calling of EnableChannel method. Explicit SW transfer
**         request is serviced regardless of disabling HW requests
**         after calling of the DisableChannel method.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/
LDD_TError DMA1_StartChannelTransfer(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  DMA1_TDescriptorRecord *DescriptorRecordPtr;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store pointer to associated descriptor record. */
  if (!GetRecord(DeviceDataPtr, DescriptorPtr, &DescriptorRecordPtr)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  if (!DescriptorRecordPtr->Initialized) {
    return ERR_NOTAVAIL;
  }
  DMA_PDD_StartTransfer(DMA_BASE_PTR, DescriptorRecordPtr->ChannelNumber); /* Explicit start of transfer. */
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_CancelChannelTransfer (component DMA_LDD)
**
**     Description :
**         The method cancels DMA transfer on channel specified by the
**         transfer descriptor input parameter DescriptorPtr. The
**         cancel takes effect after the last write of the current
**         read/write sequence and the channel retires as if the
**         request was serviced normally.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/
LDD_TError DMA1_CancelChannelTransfer(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  DMA1_TDescriptorRecord *DescriptorRecordPtr;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store pointer to associated descriptor record. */
  if (!GetRecord(DeviceDataPtr, DescriptorPtr, &DescriptorRecordPtr)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  if (!DescriptorRecordPtr->Initialized) {
    return ERR_NOTAVAIL;
  }
  DMA_PDD_CancelTransfer(DMA_BASE_PTR, DescriptorRecordPtr->ChannelNumber); /* Cancel transfer. */\
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_GetChannelStatus (component DMA_LDD)
**
**     Description :
**         The method gets a status of the DMA channel allocated for
**         the DMA transfer defined by the transfer descriptor input
**         parameter DescriptorPtr. This method is intended to perform
**         fast check of DMA channel transfer status and no validity or
**         consistency checks are performed. Possible values are
**         LDD_DMA_IDLE returned after enabling or disabling channel or
**         between separate transfers of nested transfer operation.
**         During the DMA transfer active operation LDD_DMA_BUSY is
**         returned. LDD_DMA_DONE is returned after cycle-steal, single
**         or nested transfer completes and before start of another
**         transfer or before channel enable or disable. If DMA error
**         was detected, LDD_DMA_ERR is returned.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - DMA channel status.
** ===================================================================
*/
LDD_DMA_TChannelStatus DMA1_GetChannelStatus(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  (void)DeviceDataPtr;                 /* Parameter not used, suppress not used argument warning */
  if ((DMA_PDD_GetChannelErrorFlags(DMA_BASE_PTR, DescriptorPtr->ChannelNumber)) != 0x00U) { /* Channel error check. */
    return LDD_DMA_ERROR;
  }
  if (DMA_PDD_GetDoneFlag(DMA_BASE_PTR, DescriptorPtr->ChannelNumber) != 0x00U) { /* Channel transfer done check. */
    return LDD_DMA_DONE;
  }
  if (DMA_PDD_GetBusyFlag(DMA_BASE_PTR, DescriptorPtr->ChannelNumber) == 0x00U) { /* Channel busy check. */
    return LDD_DMA_IDLE;
  }
  return LDD_DMA_BUSY;
}

/*
** ===================================================================
**     Method      :  DMA1_SetChannelSourceAddress (component DMA_LDD)
**
**     Description :
**         The method sets an source address for data to be transferred
**         by the DMA channel allocated for the DMA transfer defined by
**         the transfer descriptor parameter DescriptorPtr. This method
**         can be used to update DMA transfer source address when DMA
**         channel is enabled. New source address is stored in transfer
**         descriptor and written to associated DMA channel registers.
**         The new source address can be optionally checked for
**         consistency with rest of the transfer descriptor data.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**         Address         - Address of source data for a DMA
**                           channel allocated for a DMA transfer
**                           descriptor defined by the TCD parameter.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected source address
**                           is inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/
LDD_TError DMA1_SetChannelSourceAddress(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TAddress Address)
{
  LDD_DMA_TAddress LocalAddress;
  LDD_DMA_TChannelNumber ChannelNumber;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store associated DMA channel number. */
  if (!GetChannelNumber(DeviceDataPtr, DescriptorPtr, &ChannelNumber)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  /* New transfer descriptor consistency test - this test can be disabled by setting the "Ignore range checking"
     property to the "yes" value in the "Configuration inspector" */
  LocalAddress = DescriptorPtr->SourceAddress; /* Save actual address. */
  DescriptorPtr->SourceAddress = Address; /* Store new address in transfer descriptor. */
  if (!VerifyDescriptor(DescriptorPtr)) { /* Test consistency of new transfer descriptor. */
    DescriptorPtr->SourceAddress = LocalAddress; /* If failed, restore previous value. */
    return ERR_PARAM_DATA;
  }
  DMA_PDD_SetSourceAddress(DMA_BASE_PTR, ChannelNumber, Address);
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_SetChannelDestinationAddress (component DMA_LDD)
**
**     Description :
**         The method sets an destination address for data to be
**         transferred by the DMA channel allocated for the DMA
**         transfer defined by the transfer descriptor parameter
**         DescriptorPtr. This method can be used to update DMA
**         transfer destination address when DMA channel is enabled.
**         New destination address is stored in transfer descriptor and
**         written to associated DMA channel registers. The new source
**         address can be optionally checked for consistency with rest
**         of the transfer descriptor data.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**         Address         - Address of a destination data to
**                           be transferred to by the DMA channel
**                           allocated for a DMA transfer descriptor
**                           defined by the TCD parameter.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected source address
**                           is inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/
LDD_TError DMA1_SetChannelDestinationAddress(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TAddress Address)
{
  LDD_DMA_TAddress LocalAddress;
  LDD_DMA_TChannelNumber ChannelNumber;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store associated DMA channel number. */
  if (!GetChannelNumber(DeviceDataPtr, DescriptorPtr, &ChannelNumber)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  /* New transfer descriptor consistency test - this test can be disabled by setting the "Ignore range checking"
     property to the "yes" value in the "Configuration inspector" */
  LocalAddress = DescriptorPtr->DestinationAddress; /* Save actual address. */
  DescriptorPtr->DestinationAddress = Address; /* Store new address in transfer descriptor. */
  if (!VerifyDescriptor(DescriptorPtr)) { /* Test consistency of new transfer descriptor. */
    DescriptorPtr->DestinationAddress = LocalAddress; /* If failed, restore previous value. */
    return ERR_PARAM_DATA;
  }
  DMA_PDD_SetDestinationAddress(DMA_BASE_PTR, ChannelNumber, Address);
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_SetChannelByteCount (component DMA_LDD)
**
**     Description :
**         The method sets a byte count (size of data) to be
**         transferred by the DMA channel allocated for the DMA
**         transfer defined by the transfer descriptor input parameter
**         DescriptorPtr. This method can be used to update DMA
**         transfer byte count when DMA channel is enabled. New
**         transfer byte count is stored in transfer descriptor and
**         written to associated DMA channel registers. The new
**         transfer byte count can be optionally checked for
**         consistency with rest of the transfer descriptor data. If
**         nested operation is used, the method sets the minor (inner)
**         loop byte count.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**         ByteCount       - Byte count (size of data) to
**                           be transferred by the DMA channel allocated
**                           for a DMA transfer descriptor defined by
**                           the TCD parameter.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected byte count is
**                           inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/
LDD_TError DMA1_SetChannelByteCount(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TByteCount ByteCount)
{
  LDD_DMA_TByteCount LocalByteCount;
  LDD_DMA_TChannelNumber ChannelNumber;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store associated DMA channel number. */
  if (!GetChannelNumber(DeviceDataPtr, DescriptorPtr, &ChannelNumber)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  /* New transfer descriptor consistency test - this test can be disabled by setting the "Ignore range checking"
     property to the "yes" value in the "Configuration inspector" */
  LocalByteCount = DescriptorPtr->ByteCount; /* Save actual byte count. */
  DescriptorPtr->ByteCount = ByteCount; /* Store new byte count in transfer descriptor. */
  if (!VerifyDescriptor(DescriptorPtr)) { /* Test consistency of new transfer descriptor. */
    DescriptorPtr->ByteCount = LocalByteCount; /* If failed, restore previous value. */
    return ERR_PARAM_DATA;
  }
  DMA_PDD_SetByteCount(DMA_BASE_PTR, ChannelNumber, ByteCount);
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_SetChannelDescriptorUpdate (component DMA_LDD)
**
**     Description :
**         The method updates DMA channel allocated by transfer
**         descriptor defined by DescriptorPtr. Allocated DMA channel
**         registers are reinitialized with new values from transfer
**         descriptor structure. New tansfer descriptor is tested for
**         data consistency. The method can be called only if the
**         channel is disabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor or allocated channel is enabled.
**                           - ERR_PARAM_DATA - Selected transfer
**                           descriptor is inconsistent.
** ===================================================================
*/
LDD_TError DMA1_SetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  DMA1_TDescriptorRecord *DescriptorRecordPtr;
  LDD_DMA_TChannelNumber ChannelNumber;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store associated DMA channel number. */
  if (!GetRecord(DeviceDataPtr, DescriptorPtr, &DescriptorRecordPtr)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  else {
    if (DescriptorRecordPtr->Enabled) { /* Is channel enabled? */
      return ERR_NOTAVAIL;             /* If yes, channel descriptor can't be updated. */
    }
  }
  /* New transfer descriptor consistency test - this test can be disabled by setting the "Ignore range checking"
     property to the "yes" value in the "Configuration inspector" */
  if ((!VerifyDescriptor(DescriptorPtr)) || (DescriptorRecordPtr->ChannelNumber != DescriptorPtr->ChannelNumber)) {
    return ERR_PARAM_DATA;             /* Return transfer descriptor inconsistency error. */
  }
  DescriptorRecordPtr->Initialized = FALSE; /* Prevents from explicit SW request invokation. */
  ChannelNumber = DescriptorRecordPtr->ChannelNumber;
  InitChannel(DeviceDataPtr, DescriptorRecordPtr); /* Initialize DMA channel. */
  /* {Default RTOS Adapter} Critical section begin, general PE function is used */
  EnterCritical();
  DescriptorRecordPtr->Initialized = TRUE; /* Mark channel as initialized. */
  if (DescriptorPtr->Interrupts) {     /* Interrupts enabled? */
    DMA_PDD_EnableTransferCompleteInterrupt(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE);
    if (DescriptorPtr->OnComplete) {   /* Is transfer complete event enabled? */
      ((DMA1_TDeviceData *)DeviceDataPtr)->EventMask[ChannelNumber] |= LDD_DMA_ON_COMPLETE;
    }
    if (DescriptorPtr->OnError) {      /* Is transfer error event enabled? */
      ((DMA1_TDeviceData *)DeviceDataPtr)->EventMask[ChannelNumber] |= LDD_DMA_ON_ERROR;
    }
  }
  /* DMA channel HW requests source settings */
  DMAMUX_PDD_WriteChannelConfigurationReg(DMAMUX0_BASE_PTR, ChannelNumber, 0U); /* Clear DMA MUX channel source register. */
  if (DescriptorPtr->TriggerType != LDD_DMA_SW_TRIGGER) { /* SW trigger doesn't need MUX channel nor enabled hardware requests. */
    DMAMUX_PDD_SetChannelSource(DMAMUX0_BASE_PTR, ChannelNumber, DescriptorPtr->TriggerSource); /* Set MUX channel source. */
    if (DescriptorPtr->PeriodicTrigger) { /* Periodic trigger needed? */
      DMAMUX_PDD_EnableTrigger(DMAMUX0_BASE_PTR, ChannelNumber, PDD_ENABLE);
    }
    DMAMUX_PDD_EnableChannel(DMAMUX0_BASE_PTR, ChannelNumber, PDD_ENABLE); /* Enable channel. */
    if (DescriptorRecordPtr->Enabled) { /* Enable requests? */
      DMA_PDD_EnablePeripheralRequest(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE); /* Enable HW requests. */
    }
  }
  /* {Default RTOS Adapter} Critical section end, general PE function is used */
  ExitCritical();
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  DMA1_GetChannelDescriptorUpdate (component DMA_LDD)
**
**     Description :
**         The method gets transfer descriptor parameters of the DMA
**         channel allocated for the component. Allocated channel is
**         identified by the transfer descriptor structure address and
**         it is updated with values from the allocated DMA channel
**         registers. The method can be called only if the channel is
**         disabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**       * DescriptorPtr   - Pointer to a DMA
**                           transfer descriptor structure.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor or allocated channel is enabled.
** ===================================================================
*/
LDD_TError DMA1_GetChannelDescriptorUpdate(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  DMA1_TDescriptorRecord *DescriptorRecordPtr;
  LDD_DMA_TChannelNumber ChannelNumber;

  /* Device state test - this test can be disabled by setting the "Ignore enable test"
     property to the "yes" value in the "Configuration inspector" */
  if (!((DMA1_TDeviceData *)(DeviceDataPtr))->EnUser) { /* Is the device disabled by user? */
    return ERR_DISABLED;               /* No, return ERR_DISABLED. */
  }
  /* Check channel allocation for the transfer descriptor and eventually store associated DMA channel number. */
  if (!GetRecord(DeviceDataPtr, DescriptorPtr, &DescriptorRecordPtr)) {
    return ERR_NOTAVAIL;               /* No channel allocated for the transfer. */
  }
  else {
    if (DescriptorRecordPtr->Enabled) { /* Is channel enabled? */
      return ERR_NOTAVAIL;             /* If yes, channel descriptor can't be updated. */
    }
  }
  ChannelNumber = DescriptorRecordPtr->ChannelNumber;
  /* Source address */
  DescriptorPtr->SourceAddress = (LDD_DMA_TAddress)DMA_PDD_GetSourceAddress(DMA_BASE_PTR, ChannelNumber);
  /* Source address offset */
  if (DMA_PDD_GetSourceAddressIncrementEnabled(DMA_BASE_PTR, ChannelNumber) == 0x00U) {
    DescriptorPtr->SourceAddressIncrement = FALSE;
  }
  else {
    DescriptorPtr->SourceAddressIncrement = TRUE;
  }
  /* Destination address */
  DescriptorPtr->DestinationAddress = (LDD_DMA_TAddress)DMA_PDD_GetDestinationAddress(DMA_BASE_PTR, ChannelNumber);
  if (DMA_PDD_GetDestinationAddressIncrementEnabled(DMA_BASE_PTR, ChannelNumber) == 0x00U) {
    DescriptorPtr->DestinationAddressIncrement = FALSE;
  }
  else {
    DescriptorPtr->DestinationAddressIncrement = TRUE;
  }
  /* Transfer attributes: source transfer size, destination transfer size, source modulo, destination modulo */
  DescriptorPtr->SourceModuloSize = (LDD_DMA_TModuloSize)DMA_PDD_GetSourceAddressModulo(DMA_BASE_PTR, ChannelNumber);
  DescriptorPtr->SourceTransferSize = (LDD_DMA_TTransferSize)DMA_PDD_GetSourceDataTransferSize(DMA_BASE_PTR, ChannelNumber);
  DescriptorPtr->DestinationModuloSize = (LDD_DMA_TModuloSize)DMA_PDD_GetDestinationAddressModulo(DMA_BASE_PTR, ChannelNumber);
  DescriptorPtr->DestinationTransferSize = (LDD_DMA_TTransferSize)DMA_PDD_GetDestinationDataTransferSize(DMA_BASE_PTR, ChannelNumber);
  /* Transfer mode settings */
  if (DMA_PDD_GetCycleStealEnabled(DMA_BASE_PTR, ChannelNumber) == 0x00U) {
    DescriptorPtr->TransferMode = LDD_DMA_SINGLE_TRANSFER;
  }
  else {
    DescriptorPtr->TransferMode = LDD_DMA_CYCLE_STEAL_TRANSFERS;
  }
  /* Byte count settings */
  DescriptorPtr->ByteCount = DMA_PDD_GetByteCount(DMA_BASE_PTR, ChannelNumber);
  /* Auto-align mode settings */
  if (DMA_PDD_GetAutoAlignEnabled(DMA_BASE_PTR, ChannelNumber) == 0x00U) {
    DescriptorPtr->AutoAlign = FALSE;
  }
  else {
    DescriptorPtr->AutoAlign = TRUE;
  }
  /* Channel linking settings */
  switch (DMA_PDD_GetChannelLinkingMode(DMA_BASE_PTR, ChannelNumber)) {
    case DMA_PDD_CYCLE_STEAL_AND_TRANSFER_COMPLETE_LINKING:
      DescriptorPtr->ChannelLinkingMode = LDD_DMA_CYCLE_STEAL_AND_TRANSFER_COMPLETE_LINKING;
      DescriptorPtr->InnerLoopLinkedChannel = (LDD_DMA_TChannelNumber)DMA_PDD_GetLinkChannel1(DMA_BASE_PTR, ChannelNumber);
      DescriptorPtr->OuterLoopLinkedChannel = (LDD_DMA_TChannelNumber)DMA_PDD_GetLinkChannel2(DMA_BASE_PTR, ChannelNumber);
      break;
    case DMA_PDD_CYCLE_STEAL_LINKING:
      DescriptorPtr->ChannelLinkingMode = LDD_DMA_CYCLE_STEAL_LINKING;
      DescriptorPtr->InnerLoopLinkedChannel = (LDD_DMA_TChannelNumber)DMA_PDD_GetLinkChannel1(DMA_BASE_PTR, ChannelNumber);
      break;
    case DMA_PDD_TRANSFER_COMPLETE_LINKING:
      DescriptorPtr->ChannelLinkingMode = LDD_DMA_TRANSFER_COMPLETE_LINKING;
      DescriptorPtr->OuterLoopLinkedChannel = (LDD_DMA_TChannelNumber)DMA_PDD_GetLinkChannel1(DMA_BASE_PTR, ChannelNumber);
      break;
    default:
      DescriptorPtr->ChannelLinkingMode = LDD_DMA_LINKING_DISABLED;
      break;
  }
  if (DMA_PDD_GetRequestAutoDisableEnabled(DMA_BASE_PTR, ChannelNumber) == 0x00U) {
    DescriptorPtr->DisableAfterRequest = FALSE;
  }
  else {
    DescriptorPtr->DisableAfterRequest = TRUE;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  InitChannel (component DMA_LDD)
**
**     Description :
**         The method initializes the DMA channel allocated for the DMA 
**         transfer defined by the transfer descriptor record input 
**         parameter DescriptorRecordPtr.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void InitChannel(LDD_TDeviceData *DeviceDataPtr, DMA1_TDescriptorRecord *DescriptorRecordPtr)
{
  LDD_DMA_TTransferDescriptor *DescriptorPtr = DescriptorRecordPtr->DescriptorPtr;
  LDD_DMA_TChannelNumber ChannelNumber = DescriptorRecordPtr->ChannelNumber;

  DMA_PDD_WriteControlReg(DMA_BASE_PTR, ChannelNumber, 0U); /* Clear control register. Disable requests. */
  DMA_PDD_ClearDoneFlag(DMA_BASE_PTR, ChannelNumber); /* Clear DMA transfer done status flag. */
  /* Source address */
  DMA_PDD_SetSourceAddress(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->SourceAddress);
  /* Source address increment */
  if (DescriptorPtr->SourceAddressIncrement) {
    DMA_PDD_EnableSourceAddressIncrement(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE);
  }
  /* Destination address */
  DMA_PDD_SetDestinationAddress(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->DestinationAddress);
  /* Destination address increment */
  if (DescriptorPtr->DestinationAddressIncrement) {
    DMA_PDD_EnableDestinationAddressIncrement(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE);
  }
  /* Transfer attributes: source transfer size, destination transfer size, source modulo, destination modulo */
  DMA_PDD_SetSourceAddressModulo(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->SourceModuloSize);
  DMA_PDD_SetSourceDataTransferSize(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->SourceTransferSize);
  DMA_PDD_SetDestinationAddressModulo(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->DestinationModuloSize);
  DMA_PDD_SetDestinationDataTransferSize(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->DestinationTransferSize);
  /* Transfer mode */
  if (DescriptorPtr->TransferMode == LDD_DMA_CYCLE_STEAL_TRANSFERS) {
    DMA_PDD_EnableCycleSteal(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE); /* Enable cycle-steal mode. */
  }
  /* Byte count */
  DMA_PDD_SetByteCount(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->ByteCount);
  /* Auto-align mode settings. */
  if (DescriptorPtr->AutoAlign) {
    DMA_PDD_EnableAutoAlign(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE);
  }
  /* Asynchronous requests settings. */
  if (DescriptorPtr->AsynchronousRequests) {
    DMA_PDD_EnableAsynchronousRequests(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE);
  }
  switch (DescriptorPtr->ChannelLinkingMode) {
    case LDD_DMA_CYCLE_STEAL_AND_TRANSFER_COMPLETE_LINKING:
      DMA_PDD_SetChannelLinkingMode(DMA_BASE_PTR, ChannelNumber, DMA_PDD_CYCLE_STEAL_AND_TRANSFER_COMPLETE_LINKING); /* Set channel linking mode. */
      DMA_PDD_SetLinkChannel1(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->InnerLoopLinkedChannel); /* Set channel linked after each particular read-write operation. */
      DMA_PDD_SetLinkChannel2(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->OuterLoopLinkedChannel); /* Set channel linked after transfer byte count reaches zero. */
      break;
    case LDD_DMA_CYCLE_STEAL_LINKING:
      DMA_PDD_SetChannelLinkingMode(DMA_BASE_PTR, ChannelNumber, DMA_PDD_CYCLE_STEAL_LINKING); /* Set channel linking mode. */
      DMA_PDD_SetLinkChannel1(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->InnerLoopLinkedChannel); /* Set channel linked after each particular read-write operation. */
      break;
    case LDD_DMA_TRANSFER_COMPLETE_LINKING:
      DMA_PDD_SetChannelLinkingMode(DMA_BASE_PTR, ChannelNumber, DMA_PDD_TRANSFER_COMPLETE_LINKING); /* Set channel linking mode. */
      DMA_PDD_SetLinkChannel1(DMA_BASE_PTR, ChannelNumber, DescriptorPtr->OuterLoopLinkedChannel); /* Set channel linked after transfer byte count reaches zero. */
      break;
    default:
      /* LDD_DMA_LINKING_DISABLED: Initialization not needed. */
      break;
  }
  /* Disable after request settings */
  if (DescriptorPtr->DisableAfterRequest) {
    DMA_PDD_EnableRequestAutoDisable(DMA_BASE_PTR, ChannelNumber, PDD_ENABLE);
  }
}

/*
** ===================================================================
**     Method      :  VerifyDescriptor (component DMA_LDD)
**
**     Description :
**         The method verifies a transfer descriptor of allocated channel 
**         defined by the pointer to its address. Returns TRUE if the 
**         channel's transfer descriptor is correct, FALSE if 
**         inconsistency is detected.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static bool VerifyDescriptor(LDD_DMA_TTransferDescriptor *DescriptorPtr)
{
  /* Store source transfer size byte divider mask */
  LDD_DMA_TTransferSize SourceDividerMask, DestinationDividerMask;

  switch (DescriptorPtr->SourceTransferSize) {
    case DMA_PDD_8_BIT:
      SourceDividerMask = 0x00U;
      break;
    case DMA_PDD_16_BIT:
      SourceDividerMask = 0x01U;
      break;
    case DMA_PDD_32_BIT:
      SourceDividerMask = 0x03U;
      break;
    default:
      return FALSE;
  }
  switch (DescriptorPtr->DestinationTransferSize) {
    case DMA_PDD_8_BIT:
      DestinationDividerMask = 0x00U;
      break;
    case DMA_PDD_16_BIT:
      DestinationDividerMask = 0x01U;
      break;
    case DMA_PDD_32_BIT:
      DestinationDividerMask = 0x03U;
      break;
    default:
      return FALSE;
  }
  if ((!DescriptorPtr->AutoAlign) || (SourceDividerMask >= DestinationDividerMask)) { /* If source is auto-aligned, check destination only. */
    /* Is minor loop byte count a multiple of the destination transfer size? */
    if ((LDD_DMA_TTransferSize)(DescriptorPtr->ByteCount) & DestinationDividerMask) {
      return FALSE;                    /* If no, return. */
    }
    /* Is destination address aligned to destination transfer size? */
    if ((LDD_DMA_TTransferSize)(DescriptorPtr->DestinationAddress) & DestinationDividerMask) {
      return FALSE;                    /* If no, return. */
    }
  }
  if ((!DescriptorPtr->AutoAlign) || (SourceDividerMask < DestinationDividerMask)) { /* If destination is auto-aligned, check source only. */
    /* Is minor loop byte count a multiple of the source transfer size? */
    if ((LDD_DMA_TTransferSize)(DescriptorPtr->ByteCount) & SourceDividerMask) {
      return FALSE;                    /* If no, return. */
    }
    /* Is source address aligned to source transfer size? */
    if ((LDD_DMA_TTransferSize)(DescriptorPtr->SourceAddress) & SourceDividerMask) {
      return FALSE;                    /* If no, return. */
    }
  }
  return TRUE;                         /* Channel descriptor verified. */
}

/*
** ===================================================================
**     Method      :  GetChannelNumber (component DMA_LDD)
**
**     Description :
**         The method returns TRUE if some channel is allocated for the 
**         given descriptor, false if it is not. Number of allocated 
**         channel is returned indirectly into the ChannelNumber 
**         parameter.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static bool GetChannelNumber(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, LDD_DMA_TChannelNumber *ChannelNumber)
{
bool ChannelFound = FALSE;

  if (((DMA1_TDeviceData *)DeviceDataPtr)->ChannelRecord[DescriptorPtr->ChannelNumber]->DescriptorPtr == DescriptorPtr) {
    ChannelFound = TRUE;
    *ChannelNumber = DescriptorPtr->ChannelNumber; /* Save channel number. */
  }
  return ChannelFound;
}

/*
** ===================================================================
**     Method      :  GetRecord (component DMA_LDD)
**
**     Description :
**         The method returns TRUE if some channel is allocated for the 
**         given descriptor, false if it is not. Pointer to the 
**         descriptor record of allocated channel is returned indirectly 
**         into the DescriptorRecordPtr parameter.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static bool GetRecord(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TTransferDescriptor *DescriptorPtr, DMA1_TDescriptorRecordPtr *DescriptorRecordAddressPtr)
{
  bool RecordFound = FALSE;

  if (((DMA1_TDeviceData *)DeviceDataPtr)->ChannelRecord[DescriptorPtr->ChannelNumber]->DescriptorPtr == DescriptorPtr) {
    RecordFound = TRUE;
    *DescriptorRecordAddressPtr = ((DMA1_TDeviceData *)DeviceDataPtr)->ChannelRecord[DescriptorPtr->ChannelNumber]; /* Save descriptors record address. */
  }
  return RecordFound;
}

/*
** ===================================================================
**     Method      :  TransferCompleteInterrupt (component DMA_LDD)
**
**     Description :
**         Transfer complete interrupt service routine.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
PE_ISR(DMA1_Channel0Interrupt)
{
  /* {Default RTOS Adapter} ISR parameter is passed through the global variable */
  DMA1_TDeviceData* DeviceDataPtr = INT_DMA0__DEFAULT_RTOS_ISRPARAM;
  if (DMA_PDD_GetChannelErrorFlags(DMA_BASE_PTR, DMA1_CHANNEL_0) != 0x00U) {
    if (((DeviceDataPtr)->EventMask[DMA1_CHANNEL_0] & LDD_DMA_ON_ERROR) != 0x00U) {
      DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_0]->DescriptorPtr->OnErrorEventPtr(DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_0]->DescriptorPtr->UserDataPtr);
    }
    DMA_PDD_ClearInterruptFlags(DMA_BASE_PTR, DMA1_CHANNEL_0, DMA_PDD_TRANSFER_COMPLETE_FLAG);
  } else {
    DMA_PDD_ClearInterruptFlags(DMA_BASE_PTR, DMA1_CHANNEL_0, DMA_PDD_TRANSFER_COMPLETE_FLAG);
    if (((DeviceDataPtr)->EventMask[DMA1_CHANNEL_0] & LDD_DMA_ON_COMPLETE) != 0x00U) {
      DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_0]->DescriptorPtr->OnCompleteEventPtr(DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_0]->DescriptorPtr->UserDataPtr);
    }
  }
}
/*
** ===================================================================
**     Method      :  TransferCompleteInterrupt (component DMA_LDD)
**
**     Description :
**         Transfer complete interrupt service routine.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
PE_ISR(DMA1_Channel1Interrupt)
{
  /* {Default RTOS Adapter} ISR parameter is passed through the global variable */
  DMA1_TDeviceData* DeviceDataPtr = INT_DMA1__DEFAULT_RTOS_ISRPARAM;
  if (DMA_PDD_GetChannelErrorFlags(DMA_BASE_PTR, DMA1_CHANNEL_1) != 0x00U) {
    if (((DeviceDataPtr)->EventMask[DMA1_CHANNEL_1] & LDD_DMA_ON_ERROR) != 0x00U) {
      DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_1]->DescriptorPtr->OnErrorEventPtr(DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_1]->DescriptorPtr->UserDataPtr);
    }
    DMA_PDD_ClearInterruptFlags(DMA_BASE_PTR, DMA1_CHANNEL_1, DMA_PDD_TRANSFER_COMPLETE_FLAG);
  } else {
    DMA_PDD_ClearInterruptFlags(DMA_BASE_PTR, DMA1_CHANNEL_1, DMA_PDD_TRANSFER_COMPLETE_FLAG);
    if (((DeviceDataPtr)->EventMask[DMA1_CHANNEL_1] & LDD_DMA_ON_COMPLETE) != 0x00U) {
      DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_1]->DescriptorPtr->OnCompleteEventPtr(DeviceDataPtr->ChannelRecord[DMA1_CHANNEL_1]->DescriptorPtr->UserDataPtr);
    }
  }
}
/* END DMA1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
