/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DMAT_Mem.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : DMATransfer_LDD
**     Version     : Component 01.099, Driver 01.07, CPU db: 3.00.000
**     Compiler    : IAR ARM C Compiler
**     Date/Time   : 2012-09-23, 22:47, # CodeGen: 119
**     Abstract    :
**          This embedded component implements
**          a DMA transfer channel descriptor definition.
**     Settings    :
**          Component name                                 : DMAT_Mem
**          DMA controller device                          : DMA1
**          Channel                                        : 
**            Channel select                               : Fixed
**              Channel                                    : DMA_Channel1
**              Interrupts                                 : Enabled
**              Allocate channel                           : yes
**          Trigger                                        : 
**            Trigger source type                          : Explicit software
**          Data source                                    : 
**            External object declaration                  : 
**            Address                                      : (uint32_t)&TPM2_C0V
**            Transfer size                                : 16-bit
**            Address offset                               : 0
**            Circular buffer                              : Buffer disabled
**          Data destination                               : 
**            External object declaration                  : 
**            Address                                      : (uint32_t)&MyStaticArray
**            Transfer size                                : 16-bit
**            Address offset                               : 2
**            Circular buffer                              : 128 Bytes
**          Data size                                      : 
**            External object declaration                  : 
**            Value                                        : SAMPLE_SIZE
**          Transfer control                               : Cycle-steal
**            Disable after transfer                       : no
**            Asynchronous requests                        : Enabled
**            Channel linking                              : Disabled
**            After request complete                       : No action
**            After transfer complete                      : No action
**          Initialization                                 : 
**            Auto initialization                          : yes
**            Half complete                                : Disabled
**            Event mask                                   : 
**              OnComplete                                 : Enabled
**              OnError                                    : Enabled
**     Contents    :
**         Init             - LDD_TDeviceData* DMAT_Mem_Init(LDD_TUserData *UserDataPtr);
**         Deinit           - void DMAT_Mem_Deinit(LDD_TDeviceData *DeviceDataPtr);
**         AllocateChannel  - LDD_TError DMAT_Mem_AllocateChannel(LDD_TDeviceData *DeviceDataPtr);
**         EnableChannel    - LDD_TError DMAT_Mem_EnableChannel(LDD_TDeviceData *DeviceDataPtr);
**         DisableChannel   - LDD_TError DMAT_Mem_DisableChannel(LDD_TDeviceData *DeviceDataPtr);
**         SetSourceAddress - LDD_TError DMAT_Mem_SetSourceAddress(LDD_TDeviceData *DeviceDataPtr,...
**         SetByteCount     - LDD_TError DMAT_Mem_SetByteCount(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE DMAT_Mem. */

#include "Events.h"
#include "DMAT_Mem.h"
typedef struct {
  DMA1_TDeviceData *DMA_LDD_DeviceDataPtr; /* Pointer to the DMA_LDD component data structure */
  LDD_DMA_TTransferDescriptor *DescriptorPtr; /* Pointer to the component's transfer descriptor */
} DMAT_Mem_TDeviceData;

/* {Default RTOS Adapter} Static object used for simulation of dynamic driver memory allocation */
static DMAT_Mem_TDeviceData DeviceDataPtr__DEFAULT_RTOS_ALLOC;
/* {Default RTOS Adapter} Static object used for simulation of dynamic driver memory allocation */
static LDD_DMA_TTransferDescriptor DescriptorPtr__DEFAULT_RTOS_ALLOC;
/*
** ===================================================================
**     Method      :  DMAT_Mem_Init (component DMATransfer_LDD)
**
**     Description :
**         Initializes the DMATransfer component. Allocates memory for
**         the device data structure.
**         This method can be called only once. Before the second call
**         of Init() the Deinit() must be called first.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     Returns     :
**         ---             - Device data structure pointer.
** ===================================================================
*/
LDD_TDeviceData* DMAT_Mem_Init(LDD_TUserData *UserDataPtr)
{
  DMAT_Mem_TDeviceData *DeviceDataPtr; /* LDD device structure */
  LDD_DMA_TTransferDescriptor *DescriptorPtr; /* Transfer descriptor structure */

  /* Allocate LDD device structure */
  /* {Default RTOS Adapter} Driver memory allocation: Dynamic allocation is simulated by a pointer to the static object */
  DeviceDataPtr = &DeviceDataPtr__DEFAULT_RTOS_ALLOC;
  /* Allocate Transfer descriptor structure */
  /* {Default RTOS Adapter} Driver memory allocation: Dynamic allocation is simulated by a pointer to the static object */
  DescriptorPtr = &DescriptorPtr__DEFAULT_RTOS_ALLOC;
  DeviceDataPtr->DescriptorPtr = DescriptorPtr; /* Store pointer to the descriptor structure */
  /* Transfer descriptor initialization */
  DeviceDataPtr->DescriptorPtr->UserDataPtr = UserDataPtr; /* User device data structure pointer to be returned by the DMA_LDD component's ISR to the dynamic callback of this Descriptor */
  /* Source settings */
  DeviceDataPtr->DescriptorPtr->SourceAddress = (LDD_DMA_TAddress)(uint32_t)&TPM2_C0V; /* Address of a DMA transfer source data */
  DeviceDataPtr->DescriptorPtr->SourceTransferSize = (LDD_DMA_TTransferSize)DMA_PDD_16_BIT; /* 16-bit source data transfer size. */
  DeviceDataPtr->DescriptorPtr->SourceModuloSize = (LDD_DMA_TModuloSize)DMA_PDD_CIRCULAR_BUFFER_DISABLED; /* Circular buffer size. */
  DeviceDataPtr->DescriptorPtr->SourceAddressIncrement = FALSE; /* Address not incremented. */
  /* Destination settings */
  DeviceDataPtr->DescriptorPtr->DestinationAddress = (LDD_DMA_TAddress)(uint32_t)&MyStaticArray; /* Address of a DMA transfer destination data */
  DeviceDataPtr->DescriptorPtr->DestinationTransferSize = (LDD_DMA_TTransferSize)DMA_PDD_16_BIT; /* 16-bit destination data transfer size. */
  DeviceDataPtr->DescriptorPtr->DestinationModuloSize = (LDD_DMA_TModuloSize)DMA_PDD_CIRCULAR_BUFFER_128_BYTES; /* Circular buffer size. */
  DeviceDataPtr->DescriptorPtr->DestinationAddressIncrement = TRUE; /* Address incremented after each elemental read operation. */
  /* Byte count value */
  DeviceDataPtr->DescriptorPtr->ByteCount = (LDD_DMA_TByteCount)SAMPLE_SIZE; /* Size of data to be transferred. */
  /* Trigger settings */
  DeviceDataPtr->DescriptorPtr->TriggerType = LDD_DMA_SW_TRIGGER; /* Explicit software trigger is used */
  DeviceDataPtr->DescriptorPtr->TriggerSource = (LDD_DMA_TTriggerSource)0x00U; /* External peripheral trigger source number not used*/
  DeviceDataPtr->DescriptorPtr->PeriodicTrigger = FALSE; /* Periodic trigger mode is not used */
  DeviceDataPtr->DescriptorPtr->ChannelAutoSelection = FALSE; /* DMA channel fixed value */
  DeviceDataPtr->DescriptorPtr->ChannelNumber = (LDD_DMA_TChannelNumber)0x01U; /* DMA channel number */
  DeviceDataPtr->DescriptorPtr->AsynchronousRequests = TRUE; /* DMA channel asynchronous requests enabled. */
  /* Inner and outer loop linking settings */
  DeviceDataPtr->DescriptorPtr->ChannelLinkingMode = LDD_DMA_LINKING_DISABLED; /* Channel linking disabled. */
  DeviceDataPtr->DescriptorPtr->InnerLoopLinkedChannel = 0x00U; /* Linked DMA channel number not used. */
  DeviceDataPtr->DescriptorPtr->OuterLoopLinkedChannel = 0x00U; /* Linked DMA channel number not used. */
  /* Transfer control settings */
  DeviceDataPtr->DescriptorPtr->TransferMode = LDD_DMA_CYCLE_STEAL_TRANSFERS; /* Cycle-steal transfers - one elementary read-write transfer per request. */
  DeviceDataPtr->DescriptorPtr->DisableAfterRequest = FALSE; /* Leave enabled after request. */
  /* Interrupts and events settings */
  DeviceDataPtr->DescriptorPtr->Interrupts = TRUE; /* Interrupts are requested. */
  DeviceDataPtr->DescriptorPtr->OnComplete = TRUE; /* Event enabled in initialization code. */
  DeviceDataPtr->DescriptorPtr->OnError = TRUE; /* Event enabled in initialization code. */
  DeviceDataPtr->DescriptorPtr->OnCompleteEventPtr = &DMAT_Mem_OnComplete; /* Pointer to the OnTransferComplete event */
  DeviceDataPtr->DescriptorPtr->OnErrorEventPtr = &DMAT_Mem_OnError; /* Pointer to the OnError event */
  DeviceDataPtr->DescriptorPtr->ChannelEnabled = FALSE; /* Descriptor is not allocating nor using any channel. */
  if (PE_LDD_DeviceDataList[PE_LDD_COMPONENT_DMA1_ID] == NULL) {
    DeviceDataPtr->DMA_LDD_DeviceDataPtr = DMA1_Init(NULL);
  }
  else {
    DeviceDataPtr->DMA_LDD_DeviceDataPtr = PE_LDD_DeviceDataList[PE_LDD_COMPONENT_DMA1_ID];
  }
  /* Registration of the device structure */
  PE_LDD_RegisterDeviceStructure(PE_LDD_COMPONENT_DMAT_Mem_ID,DeviceDataPtr);
  return ((LDD_TDeviceData *)DeviceDataPtr); /* Return pointer to the data data structure. */
}

/*
** ===================================================================
**     Method      :  DMAT_Mem_Deinit (component DMATransfer_LDD)
**
**     Description :
**         Deinitializes the DMATransfer component.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/
void DMAT_Mem_Deinit(LDD_TDeviceData *DeviceDataPtr)
{
  ((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DescriptorPtr = NULL;
  /* Unregistration of the device structure */
  PE_LDD_UnregisterDeviceStructure(PE_LDD_COMPONENT_DMAT_Mem_ID);
  /* Deallocation of the Transfer descriptor structure */
  /* {Default RTOS Adapter} Driver memory deallocation: Dynamic allocation is simulated, no deallocation code is generated */
  /* Deallocation of the device structure */
  /* {Default RTOS Adapter} Driver memory deallocation: Dynamic allocation is simulated, no deallocation code is generated */
}

/*
** ===================================================================
**     Method      :  DMAT_Mem_AllocateChannel (component DMATransfer_LDD)
**
**     Description :
**         The method allocates DMA channel for the DMA transfer. This
**         method must be called before DMA channel is initialized.
**         Otherwise ERR_NOTAVAIL error code is returned after call of
**         DMA_LDD channel methods.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any possible
**                           channel with desired features to be
**                           allocated.
** ===================================================================
*/
LDD_TError DMAT_Mem_AllocateChannel(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_AllocateChannel((LDD_TDeviceData *)(((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_Mem_EnableChannel (component DMATransfer_LDD)
**
**     Description :
**         The method initializes and/or enables the DMA channel
**         allocated for the DMA transfer defined by the transfer
**         descriptor input parameter DescriptorPtr. First call of this
**         method on given DMA channel initializes it and enables HW
**         requests if Peripheral device or Always enabled trigger
**         source is selected in transfer descriptor Trigger source
**         type item. This method can be also used together with
**         Disable method to temporary switch On/Off the DMA channel HW
**         requests. In such case DMA channel registers are not
**         reinitialized again. New initialization of DMA channel can
**         be done via SetChannelDescriptorUpdate method which
**         reinitializes whole channel with new transfer descriptor.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Transfer descriptor data
**                           are inconsistent.
** ===================================================================
*/
LDD_TError DMAT_Mem_EnableChannel(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_EnableChannel((LDD_TDeviceData *)(((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_Mem_DisableChannel (component DMATransfer_LDD)
**
**     Description :
**         The method disables the DMA channel allocated for the DMA
**         transfer. However, it is still possible to start transfer
**         explicitly as SW transfer requests via StartChannelTransfer
**         method.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
** ===================================================================
*/
LDD_TError DMAT_Mem_DisableChannel(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_DisableChannel((LDD_TDeviceData *)(((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DescriptorPtr);
}

/*
** ===================================================================
**     Method      :  DMAT_Mem_SetSourceAddress (component DMATransfer_LDD)
**
**     Description :
**         The method sets an data source address for to be transferred
**         by the DMA channel allocated for the DMA transfer. This
**         method can be used to update DMA transfer source address
**         when DMA channel is enabled. New source address is stored in
**         transfer descriptor and written to associated DMA channel
**         registers. The new source address can be optionally checked
**         for consistency with rest of the transfer descriptor data.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         Address         - Address of source data for the DMA
**                           channel allocated for this TCD.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected source address
**                           is inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/
LDD_TError DMAT_Mem_SetSourceAddress(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TAddress Address)
{
  return DMA1_SetChannelSourceAddress((LDD_TDeviceData *)(((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DescriptorPtr, Address);
}

/*
** ===================================================================
**     Method      :  DMAT_Mem_SetByteCount (component DMATransfer_LDD)
**
**     Description :
**         The method sets a byte count (size of data) to be
**         transferred for the DMA transfer. This method can be used to
**         update DMA transfer byte count when DMA channel is enabled.
**         New transfer byte count is stored in transfer descriptor and
**         written to associated DMA channel registers. The new
**         transfer byte count can be optionally checked for
**         consistency with rest of the transfer descriptor data. If
**         nested operation is used, the method sets the minor (inner)
**         loop byte count.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         ByteCount       - Byte count (size of data) to
**                           be transferred by the DMA channel allocated
**                           for this TCD.
**     Returns     :
**         ---             - Error code, possible codes:
**                           - ERR_OK - OK.
**                           - ERR_SPEED - This device does not work in
**                           the active clock configuration.
**                           - ERR_DISABLED - Component or device is
**                           disabled.
**                           - ERR_NOTAVAIL - There is not any DMA
**                           channel allocated for the selected transfer
**                           descriptor.
**                           - ERR_PARAM_DATA - Selected byte count is
**                           inconsistent with rest of transfer
**                           descriptor data.
** ===================================================================
*/
LDD_TError DMAT_Mem_SetByteCount(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TByteCount ByteCount)
{
  return DMA1_SetChannelByteCount((LDD_TDeviceData *)(((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DMA_LDD_DeviceDataPtr), ((DMAT_Mem_TDeviceData *)DeviceDataPtr)->DescriptorPtr, ByteCount);
}

/* END DMAT_Mem. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
