/** ###################################################################
**     Filename    : Events.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : Events
**     Version     : Driver 01.00
**     Compiler    : ARM C/C++ Compiler
**     Date/Time   : 2012-08-17, 00:56, # CodeGen: 0
**     Abstract    :
**         This is user's event module.
**         Put your event handler code here.
**     Settings    :
**     Contents    :
**         MKL25Z_MCU_OnNMIINT - void MKL25Z_MCU_OnNMIINT(void);
**
** ###################################################################*/
/* MODULE Events */

#include "MKL25Z_MCU.h"
#include "Events.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
extern volatile bool PeriodicEvent;

/*
** ===================================================================
**     Event       :  MKL25Z_MCU_OnNMIINT (module Events)
**
**     Component   :  MKL25Z_MCU [MKL25Z128LK4]
**     Description :
**         This event is called when the Non maskable interrupt had
**         occurred. This event is automatically enabled when the <NMI
**         interrrupt> property is set to 'Enabled'.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void MKL25Z_MCU_OnNMIINT(void)
{
  /* Write your code here ... */
}

/*
** ===================================================================
**     Event       :  PeriodicInterrupt_OnCounterRestart (module Events)
**
**     Component   :  PeriodicInterrupt [TimerUnit_LDD]
**     Description :
**         Called if counter overflow/underflow or counter is
**         reinitialized by modulo or compare register matching.
**         OnCounterRestart event and Timer unit must be enabled. See
**         <SetEventMask> and <GetEventMask> methods. This event is
**         available only if a <Interrupt> is enabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. The pointer passed as
**                           the parameter of Init method.
**     Returns     : Nothing
** ===================================================================
*/
void PeriodicInterrupt_OnCounterRestart(LDD_TUserData *UserDataPtr)
{
	PeriodicEvent = TRUE;
}

/* END Events */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
